/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   SELOR_ERRORS                                                                  
   Programado por Lucas Priori                                                   
   Versao: 1.00                                                                  
                                                                                 
   Compilar:                                                                     
   Linux: gcc selor_errors.c -o selor_errors -lmysqlclient                       
   FreeBSD:  gcc selor_errors.c -o selor_errors -DFreeBSD -L/usr/local/lib/mysql -lmysqlclient
                                                                                 
  *******************************************************************            
  Selor_errors e' um utilitario do pacote Selor para se registrar e              
  controlar emails recusados                                                     
  Copyright (C) 2014 Lucas Priori                                                
                                                                                 
  This program is free software; you can redistribute it and/or                  
  modify it under the terms of the GNU General Public License                    
  as published by the Free Software Foundation; either version 2                 
  of the License, or (at your option) any later version.                         
                                                                                 
  This program is distributed in the hope that it will be useful,                
  but WITHOUT ANY WARRANTY; without even the implied warranty of                 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  
  GNU General Public License for more details.                                   
                                                                                 
  You should have received a copy of the GNU General Public License              
  along with this program; if not, write to the Free Software                    
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
#include<stdio.h>
#include<stdlib.h>
#include<fcntl.h>
#include<string.h>
#include<time.h>
#ifdef FreeBSD
 #include "/usr/local/include/mysql/mysql.h"
 #include "/usr/local/include/mysql/errmsg.h"
#else
 #include<mysql/mysql.h>
 #include<mysql/errmsg.h>
#endif

#define VERSAO "1.0b"
// --- Defines do Banco de Dados ---
#define HOST "127.0.0.1"
#define DB "selor_errors"
#define USER "user_selor"
#define PASS "pass_selor"
// ----
#define TAM_buffer 2048

//---------------------------------------------------
//      Variaveis GLOBAIS                            
//---------------------------------------------------
MYSQL *mysql = NULL;
MYSQL_RES *myres; 
MYSQL_ROW myreg;
char host[100]=HOST;
char db[100]=DB;
char user[100]=USER;
char pass[100]=PASS;
// ---
time_t tempo;
struct str_tempo{
 char dia_semana[3];
 char fim1;
 char mes[3];
 char fim2;
 char dia[2];
 char fim3;
 char hora[2];
 char fim4;
 char minuto[2];
 char fim5;
 char segundo[2];
 char fim6;
 char ano[4];
 char fim7;
}desc_tempo;
// ---
char buffer[TAM_buffer + 1];
char op_c[200];
char op_b[200];
char op_r[200];
char op_f[200];
char op_F[200];
char op_m[2000];
char op_clean[10];


// --------- Funcoes Internas ---------
void erro_mysql(void);
void ret_tempo(void);

// --------- Funcao Principal ---------
int main(int argc, char *argv[]){
 unsigned int cont1=0;
 int retorno=0;
 
 
 if(argc == 1){
  Ajuda:
  printf("Selor_errors V %s\n", VERSAO);
  printf(" Options          | Description\n");
  printf("  -c <mail rcpt>    Seek a recipient in database and returns these values\n");
  printf("                     0 = No address found\n");
  printf("                     1 = The address was found and has a refuses message\n");
  printf("                     2 = Error. Consulte the error message\n");
  printf("                     A message with the refused_count is displayed\n");
  printf("  -b <mail rcpt>    Seek a recipient in database and returns these values\n");
  printf("                     0 = No address found\n");
  printf("                     1 = The address was found and has a refuses message\n");
  printf("                     2 = Error. Consulte the error message\n");
  printf("                     A message with the last_msg_refused is displayed\n");
  printf("  -r <mail rcpt>    To register a refused message. Use the options -m and -f\n");
  printf("  -f <mail from>    To specify a recipient address to the registry\n");
  printf("  -F <mail from>    Seek a from address in database and returns these values\n");
  printf("                     0 = No address found\n");
  printf("                     1 = The address was found and has a refuses message\n");
  printf("                     2 = Error. Consulte the error message\n");
  printf("                     A message with the refused_count is displayed\n");
  printf("  -m '<ref. msg>'   To specify a refused message to the registry\n");
  printf("  --clean <days>    To delete records older than the specified days\n");
  printf("\n --- Connection Options ---\n");
  printf(" --host <host>      To specify the host of database\n");
  printf(" --db   <database>  To specify the database name\n");
  printf(" --user <username>  To specify the user of database\n");
  printf(" --pass <password>  To specify the password of database\n");
  printf("  Obs: If you do not use these connection options, then,\n        the 'defines' compiled with the program will be used\n");
  return 0;
 }
 
 op_c[0]=0;
 op_r[0]=0;
 op_f[0]=0;
 op_m[0]=0;
 op_clean[0]=0;
 
 // Lendo parametros 
 for(cont1=1; cont1<argc; cont1++){
  if(!strcmp(argv[cont1], "-c")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_c, sizeof(op_c)-1,"%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "-b")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_b, sizeof(op_b)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "-r")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_r, sizeof(op_r)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "-f")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_f, sizeof(op_f)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "-F")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_F, sizeof(op_F)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "-m")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_m, sizeof(op_m)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "--clean")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(op_clean, sizeof(op_clean)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "--host")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(host, sizeof(host)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "--db")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(db, sizeof(db)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "--user")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(user, sizeof(user)-1, "%s", argv[cont1]);
  
  }else if(!strcmp(argv[cont1], "--pass")){
   if(!argv[++cont1])goto Ajuda;
   snprintf(pass, sizeof(pass)-1, "%s", argv[cont1]);
  
  }else goto Ajuda;
 }
 
 cont1=0;
 if(op_c[0])cont1++;
 if(op_b[0])cont1++;
 if(op_r[0])cont1++;
 if(op_F[0])cont1++;
 if(op_clean[0])cont1++;
 if(cont1 != 1){
  printf("You need to use one of these options: '-c', '-b', '-r', '-F' or '--clean'\n");
  return 2;
 }
 
 // Ligando as funcoes do MySQL
 mysql = mysql_init(NULL);
 if(!mysql){
  printf("Mysql_init() Fail");
  return 2;
 }
 // Conectando-se ao banco de dados
 if(!mysql_real_connect(mysql, host, user, pass, db, 0, NULL, 0))erro_mysql();
 
 // -- Checando o email no banco de dados e retornando o numero de mensagens de recusa--
 if(op_c[0]){
  if(op_f[0])snprintf(buffer, TAM_buffer, "SELECT refused_count FROM dests_refused WHERE mail_rcpt='%s' AND mail_from='%s'", op_c, op_f);
  else snprintf(buffer, TAM_buffer, "SELECT Sum(refused_count) Num_refuseds FROM dests_refused WHERE mail_rcpt='%s'", op_c);
  if(mysql_query(mysql, buffer))erro_mysql();
  if((myres=mysql_store_result(mysql))){
   if((myreg=mysql_fetch_row(myres)) && myreg[0] != NULL){
    // Registro encontrado
    printf("%s", myreg[0]);
    retorno=1;
   }
   mysql_free_result(myres);
  }
  
 // -- Checando o email no banco de dados e retornando a mensagem de recusa--
 }else if(op_b[0]){
  if(op_f[0])snprintf(buffer, TAM_buffer, "SELECT last_msg_refused FROM dests_refused WHERE mail_rcpt='%s' AND mail_from='%s'", op_b, op_f);
  else snprintf(buffer, TAM_buffer, "SELECT last_msg_refused FROM dests_refused WHERE mail_rcpt='%s' LIMIT 1", op_b);
  if(mysql_query(mysql, buffer))erro_mysql();
  if((myres=mysql_store_result(mysql))){
   if((myreg=mysql_fetch_row(myres)) && myreg[0] != NULL){
    // Registro encontrado
    printf("%s", myreg[0]);
    retorno=1;
   }
   mysql_free_result(myres);
  }
  
 // -- Checando o remetente no banco de dados e retornando o numero de mensagens de recusa --
 }else if(op_F[0]){
  snprintf(buffer, TAM_buffer, "SELECT Sum(refused_count) Num_refuseds FROM dests_refused WHERE mail_from='%s'", op_F);
  if(mysql_query(mysql, buffer))erro_mysql();
  if((myres=mysql_store_result(mysql))){
   if((myreg=mysql_fetch_row(myres)) && myreg[0] != NULL){
    // Registro encontrado
    printf("%s", myreg[0]);
    retorno=1;
   }
   mysql_free_result(myres);
  } 
 // -- Registrando o email no banco de dados --
 }else if(op_r[0]){
  snprintf(buffer, TAM_buffer, "SELECT id FROM dests_refused WHERE mail_rcpt='%s' AND mail_from='%s'", op_r, op_f);
  if(mysql_query(mysql, buffer))erro_mysql();
  if((myres=mysql_store_result(mysql))){
   time(&tempo);
   ret_tempo();
   if((myreg=mysql_fetch_row(myres))){
    // Registro encontrado
    cont1=atoi(myreg[0]);
    mysql_free_result(myres);
    snprintf(buffer, TAM_buffer, "UPDATE dests_refused SET date_recv=%s%s%s,time_recv=%s%s%s,mail_from='%s',mail_rcpt='%s',refused_count=refused_count+1,last_msg_refused='%s' WHERE id=%u",
                                desc_tempo.ano, desc_tempo.mes, desc_tempo.dia, desc_tempo.hora, desc_tempo.minuto, desc_tempo.segundo, op_f, op_r, op_m, cont1);
    if(mysql_query(mysql, buffer))erro_mysql();
   }else {
    mysql_free_result(myres);
    snprintf(buffer, TAM_buffer, "INSERT INTO dests_refused (date_recv,time_recv,mail_from,mail_rcpt,refused_count,last_msg_refused) VALUES (%s%s%s,%s%s%s,'%s','%s',1,'%s')",
                                desc_tempo.ano, desc_tempo.mes, desc_tempo.dia, desc_tempo.hora, desc_tempo.minuto, desc_tempo.segundo, op_f, op_r, op_m);
    if(mysql_query(mysql, buffer))erro_mysql();
   }
  }
  
 // -- Limpando o banco de dados  --
 }else if(op_clean[0]){
  cont1=atoi(op_clean)*60*60*24;
  time(&tempo);
  tempo-=cont1;
  ret_tempo();
  snprintf(buffer, TAM_buffer, "DELETE FROM dests_refused WHERE date_recv<%s%s%s", desc_tempo.ano, desc_tempo.mes, desc_tempo.dia);
  if(mysql_query(mysql, buffer))erro_mysql();
 }
 
 mysql_close(mysql);
 return retorno;
}

// ---------------------------------------------
void erro_mysql(){
 printf("MySQL ERROR: %s\n", mysql_error(mysql));
 exit(2);
}


// ---------------------------------------------
void ret_tempo(void){
 memcpy(&desc_tempo, ctime(&tempo), sizeof(desc_tempo));
 desc_tempo.fim1=0;
 desc_tempo.fim2=0;
 desc_tempo.fim3=0;
 desc_tempo.fim4=0;
 desc_tempo.fim5=0;
 desc_tempo.fim6=0;
 desc_tempo.fim7=0;
 if(desc_tempo.dia[0]==' ')desc_tempo.dia[0]='0';
 if((desc_tempo.mes[0]=='J')&&(desc_tempo.mes[1]=='a')&&(desc_tempo.mes[2]=='n'))strcpy(desc_tempo.mes,"01");
 else if((desc_tempo.mes[0]=='F')&&(desc_tempo.mes[1]=='e')&&(desc_tempo.mes[2]=='b'))strcpy(desc_tempo.mes,"02");
 else if((desc_tempo.mes[0]=='M')&&(desc_tempo.mes[1]=='a')&&(desc_tempo.mes[2]=='r'))strcpy(desc_tempo.mes,"03");
 else if((desc_tempo.mes[0]=='A')&&(desc_tempo.mes[1]=='p')&&(desc_tempo.mes[2]=='r'))strcpy(desc_tempo.mes,"04");
 else if((desc_tempo.mes[0]=='M')&&(desc_tempo.mes[1]=='a')&&(desc_tempo.mes[2]=='y'))strcpy(desc_tempo.mes,"05");
 else if((desc_tempo.mes[0]=='J')&&(desc_tempo.mes[1]=='u')&&(desc_tempo.mes[2]=='n'))strcpy(desc_tempo.mes,"06");
 else if((desc_tempo.mes[0]=='J')&&(desc_tempo.mes[1]=='u')&&(desc_tempo.mes[2]=='l'))strcpy(desc_tempo.mes,"07");
 else if((desc_tempo.mes[0]=='A')&&(desc_tempo.mes[1]=='u')&&(desc_tempo.mes[2]=='g'))strcpy(desc_tempo.mes,"08");
 else if((desc_tempo.mes[0]=='S')&&(desc_tempo.mes[1]=='e')&&(desc_tempo.mes[2]=='p'))strcpy(desc_tempo.mes,"09");
 else if((desc_tempo.mes[0]=='O')&&(desc_tempo.mes[1]=='c')&&(desc_tempo.mes[2]=='t'))strcpy(desc_tempo.mes,"10");
 else if((desc_tempo.mes[0]=='N')&&(desc_tempo.mes[1]=='o')&&(desc_tempo.mes[2]=='v'))strcpy(desc_tempo.mes,"11");
 else if((desc_tempo.mes[0]=='D')&&(desc_tempo.mes[1]=='e')&&(desc_tempo.mes[2]=='c'))strcpy(desc_tempo.mes,"12");
}


/*
 CREATE TABLE dests_refused (
  id BIGINT UNSIGNED AUTO_INCREMENT,
  date_recv INT UNSIGNED,
  time_recv INT UNSIGNED,  
  mail_from VARCHAR(150),
  mail_rcpt VARCHAR(150),
  refused_count INT UNSIGNED,
  last_msg_refused VARCHAR(255),
  PRIMARY KEY(id),
  INDEX idx_mail_from (mail_from),
  INDEX idx_mail_rcpt (mail_rcpt)
 )
*/

